<?php
	
	class LSQ_GF {
			
		public function __construct( $AccessKey = null, $SecretKey = null ) {
			
			$this->akey = $AccessKey;
			$this->skey = $SecretKey;
			
		}

		/**
		 * User Authentication.
		 * 
		 * @access public
		 * @static
		 * @param string $AccessKey (default: NULL)
		 * @param string $SecretKey (default: NULL)
		 * @return true or false
		 */
		public function user_authentication() {

			$AccessKey = $this->akey;
			
			$SecretKey = $this->skey;
			
			/* User Authentication */
			$url = 'https://api.leadsquared.com/v2/Authentication.svc/UserByAccessKey.Get?accessKey='.$AccessKey.'&secretKey='.$SecretKey;
			
			/* Execute request. */
			$response = wp_remote_request( $url , array(
				'method' => 'GET'
			) );
			
			if ( is_wp_error( $response ) ) {	
				die( 'Request failed. '. $response->get_error_messages() );	
			} else {
				if($response['response']['code']  == '200'){
					return true;
				} else {
					return false;
				}			
			}		
		}
		
		
		/**
		 * Get the list of users.
		 * 
		 * @access public
		 * @return array $users
		 */
		public function get_users() {

			$url = 'https://api.leadsquared.com/v2/UserManagement.svc/Users.Get?accessKey='.$this->akey.'&secretKey='.$this->skey;
			
			$response = wp_remote_request( $url , array(
				'method' => 'GET'
			) );
			
			/* If WP_Error, die. Otherwise, return JSON. */
			if ( is_wp_error( $response ) ) {
				
				die( 'Request failed. '. $response->get_error_messages() );
				
			} else {
	
					$response_body = json_decode( $response['body'], true );
					return  $response_body;
						
			}
			
		}
		/**
		 * Get the Lead Meta Data
		 * 
		 * @access public
		 * @return array $users
		 */
		public function get_mete_data() {

			$url = 'https://api.leadsquared.com/v2/LeadManagement.svc/LeadsMetaData.Get?accessKey='.$this->akey.'&secretKey='.$this->skey;
			
			$response = wp_remote_request( $url , array(
				'method' => 'GET'
			) );
			
			/* If WP_Error, die. Otherwise, return JSON. */
			if ( is_wp_error( $response ) ) {
				
				die( 'Request failed. '. $response->get_error_messages() );
				
			} else {
	
					$response_body = json_decode( $response['body'], true );
					return  $response_body;
						
			}
			
		}
		
		/**
		 * Insert new record.
		 * 
		 * @access public
		 * @return array
		 */
		public function insert_record($lead,$ProspectID = NULL) {
			if($ProspectID){
				$get_url = 'https://api.leadsquared.com/v2/LeadManagement.svc/Leads.GetById?accessKey='.$this->akey.'&secretKey='.$this->skey.'&id='.$ProspectID;	
				$getresponse = wp_remote_request( $get_url , array(
						'method' => 'GET'
					) );
				
				if ( is_wp_error( $getresponse ) ) {
					
					$request_url = 'https://api.leadsquared.com/v2/LeadManagement.svc/Lead.Convert?accessKey='.$this->akey.'&secretKey='.$this->skey.'&leadId='.$ProspectID;
					$json_data = json_encode($lead,true);
					
				} else {
		
						$getresponse_body = json_decode( $getresponse['body'], true );
						if($getresponse_body){
							$request_url    = 'https://api.leadsquared.com/v2/LeadManagement.svc/Lead.CreateOrUpdate?postUpdatedLead=false&accessKey='.$this->akey.'&secretKey='.$this->skey;
							$Source         = $getresponse_body[0]['Source'];
							$SourceMedium   = $getresponse_body[0]['SourceMedium'];
							$SourceCampaign = $getresponse_body[0]['SourceCampaign'];
							$additional_lead = '[{"Attribute": "Source","Value": "'.$Source.'"},{"Attribute": "SourceMedium","Value": "'.$SourceMedium.'"},{"Attribute": "SourceCampaign","Value": "'.$SourceCampaign.'"}]';
							$ad_array = json_decode($additional_lead,true);
							$new_lead = array_merge($lead, $ad_array);
							$json_data = json_encode($new_lead,true);
						} else {
							$request_url = 'https://api.leadsquared.com/v2/LeadManagement.svc/Lead.Convert?accessKey='.$this->akey.'&secretKey='.$this->skey.'&leadId='.$ProspectID;
							$json_data = json_encode($lead,true);
						}	
				}
			} else {
				$request_url = 'https://api.leadsquared.com/v2/LeadManagement.svc/Lead.CreateOrUpdate?postUpdatedLead=false&accessKey='.$this->akey.'&secretKey='.$this->skey;
				$json_data = json_encode($lead,true);
			}
			
			$response = wp_remote_request( $request_url, array( 
				'method'  => 'POST',
				'headers' => array('Content-Type' => 'application/json','Content-Length' => strlen($json_data)),
				'body'    => $json_data
			) );
			
			if($response['response']['code']  == '200'){
							$response_body = json_decode( $response['body'], true );
					return  $response_body;
						} else {
							$response_body = json_decode( $response['body'], true );
					return  $response_body;
						}
		}	
	}